local root = getRootElement()
local resourceRoot = getResourceRootElement ( getThisResource() )
local dummy = nil
--local dummy2 = createObject ( 1337, 0, 10, 4 )

function spawnAllPlayers()
	players = getElementsByType ( "player" )
	for k,v in pairs(players) do
		r = 5
		angle = math.random(0, 359.99) --random angle between 0 and 359.99
		centerX = 38.977
		centerY = -19.282
		spawnX = r*math.cos(angle) + centerX --circle trig math
		spawnY = r*math.sin(angle) + centerY --circle trig math
		spawnAngle = 360 - math.deg( math.atan2 ( (0 - spawnX), (0 - spawnY) ) )
		spawnPlayer ( v, spawnX, spawnY, 2.5, spawnAngle )	
	end
end

function spawnAndBindJoinedPlayer()
	local player = source
	setTimer ( createTornado, 1000, 1 )
	setTimer ( function()
		r = 5
		angle = math.random(0, 359.99) --random angle between 0 and 359.99
		centerX = 38.977
		centerY = -19.282
		spawnX = r*math.cos(angle) + centerX --circle trig math
		spawnY = r*math.sin(angle) + centerY --circle trig math
		spawnAngle = 360 - math.deg( math.atan2 ( (0 - spawnX), (0 - spawnY) ) )
		spawnPlayer ( player, spawnX, spawnY, 2.5, spawnAngle )	

		bindKey ( player, "num_8", "down", move, "up" )
		bindKey ( player, "num_4", "down", move, "left" )
		bindKey ( player, "num_6", "down", move, "right" )
		bindKey ( player, "num_5", "down", move, "down" )
	end, 1500, 1 )
end


function createTornado()
	dummy = createObject ( 1337, 0, 0, 2 )
	setElementDimension ( dummy, 69 )
	triggerClientEvent ( "onTornado", dummy )
	-- outputChatBox ( "..." )
end

-- function lol()
	-- local x, y, z = getElementPosition ( dummy2 )
	-- local rotX, rotY, rotZ = getObjectRotation ( dummy2 )
	-- local x2, y2, z2 = getElementPosition ( getPlayerFromNick ( "norby89" ) )
	-- local newRotZ = math.deg ( math.asin ( ( x - x2 ) / getDistanceBetweenPoints2D ( x, y, x2, y2 ) ) )
	-- outputChatBox ( newRotZ )
	-- setObjectRotation ( dummy2, rotX, rotY, newRotZ )
	
-- end
-- setTimer ( lol, 100, 0 )

function move ( player, cmd, state, direction )
	local x, y, z = getElementPosition ( dummy )
	if ( direction == "up" ) then
		moveObject ( dummy, 10000, x, y + 100, z )
	elseif ( direction == "left" ) then
		moveObject ( dummy, 10000, x - 100, y, z )
	elseif ( direction == "right" ) then
		moveObject ( dummy, 10000, x + 100, y, z )
	elseif ( direction == "down" ) then
		moveObject ( dummy, 10000, x, y - 100, z )
	end
end

function bindKeys()
	spawnAllPlayers()
	setTimer ( createTornado, 1000, 1 )
	for i, v in ipairs ( getElementsByType ( "player" ) ) do
		bindKey ( v, "num_8", "down", move, "up" )
		bindKey ( v, "num_4", "down", move, "left" )
		bindKey ( v, "num_6", "down", move, "right" )
		bindKey ( v, "num_5", "down", move, "down" )
	end
end	

addEventHandler ( "onResourceStart", resourceRoot, bindKeys )
addEventHandler ( "onPlayerJoin", root, spawnAndBindJoinedPlayer )